/**
 * Confrontation section of Varanar, Night Two.
 * @param {NightTwoController} controller The Night Two controller.
 */
function NightTwoLewdWin(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new NightTwoLewdWinContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var weapon = ctrl.misc.weapon();
        global.kobold.history.shared.varanar.nightTwo.fought = true;
        var toReturn = `[p]
                            No.
                            You aren't going to let them do this.
                            You can't and you [b]won't[/b] get [b]anywhere[/b] near that filthy human's disgusting groin, let alone put his [i]thing[/i] in your mouth!
                            [b]Over your dead body.[/b]
                            They may be stronger than you, they may outnumber you, they may have you in an arm-grip,
                            but all of that just means they [b]won't[/b] be [i]expecting[/i] you to go on the offensive.
                        [/p]
                        [p]
                            They think they have you scared shitless, that you're just another kobold for them to [b]bully[/b] and [b]abuse[/b],
                            that you won't put up a fight simply because this is [b]their[/b] town.
                            But you aren't any ordinary run-of-the-mill lizard.
                            The other members of your kind may be content being thieves, or bandits or prostitutes or beggars, but not [b]you[/b].
                            You may be a thief right now, but you [b]aspire[/b] to be a [b]knight[/b].
                            And knights don't back down in the face of adversity.
                            They charge head-forward into danger.
                            Just like you're about to do.
                        [/p]
                        [p]
                            While one of your arms is being restrained, you reach for your ${global.kobold.inventory.createItemWithTooltip(weapon)} with the other.
                            With your head being forced ever-closer to the drunkard's dick, you decide to strike before your snout is pushed into his unwashed pubic hair.
                            Swiftly and silently, you [b]surge[/b] your weapon forwards,
                            shoving the pointy-end directly into the ruffian's exposed groin, stabbing him in his flaccid length.
                            The man screams in pain.
                            His companions laugh out loud, thinking you bit him.
                            Their laughter comes to a halt, however, as the group slowly realizes what has transpired.
                        [/p]
                        [p]
                            You pull your weapon from the pantless delinquent's rear, and in one swift move, you bring it to bear on the person holding your arm.
                            Blindly stabbing backwards, you land a seemingly solid strike on the human's abdomen.
                            He loses his hold on your arm nigh-instantly as your ${global.kobold.inventory.createItemWithTooltip(weapon)} sinks into his gut.
                            The man whose ass you perforated tumbles to the ground.
                            Blood oozes liberally from his mutilated ass.
                            The guy behind you stumbles backwards, clutching his wounded belly.
                            Communal panic settles in.
                            [i]Perfect[/i].
                        [/p]
                        [p]
                            Your freedom regained, you drop into a combat stance and begin to wildly swing your weapon about in all directions,
                            attempting and succeeding in pushing back the humans surrounding you.
                            Their encircling formation broken, one of their comrades downed, and the other vomiting blood, the frightened men turn tail and run away.
                            By growing hysteria, fostered by your ballsy outburst, you have managed to drive the overwhelming odds to flee,
                            causing an entire group of intoxicated humans to sprint away from a single kobold with a weapon,
                            not even bothering to pick up their wounded in the process.
                        [/p]
                        [p]
                            As the dust settles, the only people left in the street are you, and the guy you stabbed in the butt.
                            Only one of you is standing, and it isn't him.
                            You take a few deep breaths, slowly calming down from the adrenaline rush that took over you.
                            You did it.
                            You scared them off.
                            You showed them that they can't just push kobolds around without any repercussions,
                            that you and your kind alike [b]will[/b] fight back if cornered.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = ctrl.fightWin.continued() ? "disabled" : "";
        var isSelected = ctrl.fightWin.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.fightWin.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.fightWin.change();
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        next.registerListeners();

        if (ctrl.fightWin.continued()) {
            return;
        }

        registerNextListener();
    };
}
